; JAWS 4.5 scrpt for Tera Term Pro - a terminal emulator
; Corresponds to Tera Term Pro Ver 2.3

include "hjconst.jsh"
include "hjGlobal.jsh"

globals
  int TTermCursorMode

Function AutoStartEvent()
  ;  Read settings from an ini file
  let TTermCursorMode = IniReadInteger("CursorOptions", "CursorEchoMode", 0, "ttermpro.ini")
EndFunction

Function AutoFinishEvent()
  ; Write settings to an ini file
  IniWriteInteger ("CursorOptions", "CursorEchoMode", TTermCursorMode, "ttermpro.ini")
EndFunction

Script SayPriorLine()
  if (!isPcCursor()) then
    PerformScript SayPriorLine()
    return
  endif
  if (TTermCursorMode == 0
    && GetCurrentScriptKeyName() == "UpArrow") then
    PerformScript SayPriorLine()
  elif (TTermCursorMode == 1) then
    TypeCurrentScriptKey()
    SayLine()
  else TypeCurrentScriptKey()
  endif
EndScript

Script SayNextLine()
  if (!isPcCursor()) then
    PerformScript SayNextLine()
    return
  endif
  if (TTermCursorMode == 0
    && GetCurrentScriptKeyName() == "DownArrow") then
    PerformScript SayNextLine()
  elif (TTermCursorMode == 1) then
    TypeCurrentScriptKey()
    SayLine()
  else TypeCurrentScriptKey()
  endif
EndScript

Script SayPriorCharacter()
  if (!isPcCursor()) then
    PerformScript SayPriorCharacter()
    return
  endif
  if (TTermCursorMode == 0
    && GetCurrentScriptKeyName() == "LeftArrow") then
    PerformScript SayPriorCharacter()
  elif (TTermCursorMode == 1) then
    TypeCurrentScriptKey()
    SayCharacter()
  else TypeCurrentScriptKey()
  endif
EndScript

Script SayNextCharacter()
  if (!isPcCursor()) then
    PerformScript SayNextCharacter()
    return
  endif
  if (TTermCursorMode == 0
    && GetCurrentScriptKeyName() == "RightArrow") then
    PerformScript SayNextCharacter()
  elif (TTermCursorMode == 1) then
    TypeCurrentScriptKey()
    SayCharacter()
  else TypeCurrentScriptKey()
  endif
EndScript

Script JawsBackSpace()
  if (TTermCursorMode < 2) then
    PerformScript JawsBackSpace()
  else TypeCurrentScriptKey()
  endif
EndScript

Script ToggleCursorMode ()
  if (TTermCursorMode < 2) then
      let TTermCursorMode = TTermCursorMode + 1
  else let TTermCursorMode = 0
  endif
  if (TTermCursorMode == 0) then
    SayFormattedMessage (OT_MESSAGE, "Normal Mode", "Normal")
  elif (TTermCursorMode == 1) then
    SayFormattedMessage(OT_MESSAGE, "Emacs Mode", "Emacs")
  elif (TTermCursorMode == 2) then
    SayFormattedMessage(OT_MESSAGE, "Silent Mode", "Silent")
  endif
EndScript

